<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib uri="http://wso2.org/projects/carbon/taglibs/carbontags.jar"
           prefix="carbon" %>
<%@ taglib uri="http://java.sun.com/jstl/core" prefix="c" %>
<%@ page import="org.apache.axis2.context.ConfigurationContext" %>
<%@ page import="org.apache.axis2.context.MessageContext" %>
<%@ page import="org.wso2.carbon.CarbonConstants" %>
<%@ page import="org.wso2.carbon.dashboard.common.IUserPrefsService" %>
<%@ page import="org.wso2.carbon.dashboard.ui.DashboardUiUtils" %>
<%@ page import="org.wso2.carbon.dashboard.ui.UserPrefsServiceClient" %>
<%@ page import="org.wso2.carbon.registry.core.RegistryConstants" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIMessage" %>
<%@ page import="org.wso2.carbon.ui.CarbonUIUtil" %>
<%@ page import="org.wso2.carbon.utils.ServerConstants" %>
<%
    String loggeduser = (String) request.getSession().getAttribute("logged-user");
    boolean userLogedIn = true;

    // Getting the Dashboard name. Will be null in case of portal mode.
    String dashboardName = request.getParameter("name");
    if ((dashboardName == null) | ("null".equals(dashboardName))) {
        dashboardName = null;
    }

    //In some products the add gadget / add tabs etc buttons should be hidden by default
    String hideOptions = request.getParameter("hideOpt");
    if ((hideOptions == null) || ("null".equals(hideOptions))) {
        hideOptions = null;
    }

    // Adding tenant domain if available.
    String tenantDomain = "";
    if (request.getSession().getAttribute(RegistryConstants.TENANT_DOMAIN) != null) {
        tenantDomain = "@" + (String) request.getSession().getAttribute(RegistryConstants.TENANT_DOMAIN);
    }

    if ((request.getSession().getAttribute("logged-user") == null) && (dashboardName == null)) {
        userLogedIn = false;
    }
    IUserPrefsService userPrefsServiceClient = null;
    String backendServerURL = null;
    String adminConsoleUrl;
    try {
        backendServerURL = CarbonUIUtil.getServerURL(config.getServletContext(), session);
        adminConsoleUrl = CarbonUIUtil.getAdminConsoleURL(request);
        ConfigurationContext configContext =
                (ConfigurationContext) config.getServletContext()
                        .getAttribute(CarbonConstants.CONFIGURATION_CONTEXT);
        String cookie = (String) session.getAttribute(ServerConstants.ADMIN_SERVICE_COOKIE);


        userPrefsServiceClient =
                (IUserPrefsService) CarbonUIUtil.getServerProxy(new UserPrefsServiceClient(cookie,
                        backendServerURL,
                        configContext,
                        request.getLocale()),
                        IUserPrefsService.class, session);

    } catch (Exception e) {
        CarbonUIMessage uiMsg = new CarbonUIMessage(CarbonUIMessage.ERROR, e.getMessage(), e);
        session.setAttribute(CarbonUIMessage.ID, uiMsg);
%>
<jsp:include page="../admin/error.jsp"/>
<%
        return;

    }

    String currentActiveTab = request.getParameter("tab");
    if (currentActiveTab == null) {
        // Default to Home
        currentActiveTab = "0";
    } else if (userLogedIn) {
        // Check if this is a valid tab
        String[] userTabs =
                userPrefsServiceClient.getTabLayout(loggeduser, dashboardName).split(",");
        boolean validTab = false;
        for (String userTab : userTabs) {
            if (userTab.equals(currentActiveTab)) {
                validTab = true;
                break;
            }
        }

        if (!validTab) {
            // Revert to home
            currentActiveTab = "0";
        }

    }

    String[] gadgetUrls = null;
    boolean isReadOnlyMode = false;
    try {
        if (dashboardName == null) {
            // We are in portal mode
            //Checking for the home tab, the default gadgets will only for a NEW user (New user has only 1 tab)
            if ("0".equals(currentActiveTab)) {
                gadgetUrls = userPrefsServiceClient.getGadgetUrlSetForUnSignedUser();
            }
            //Checking for the home tab and logged state, the default gadgets will only for a NEW user (New user has only 1 tab)
            if (userLogedIn && ("0".equals(currentActiveTab))) {
                gadgetUrls = userPrefsServiceClient.getDefaultGadgetUrlSet(loggeduser);
            }
        } else {
            // We are in embedded mode
            gadgetUrls = userPrefsServiceClient.getGadgetUrlsToLayout(loggeduser, currentActiveTab, dashboardName, backendServerURL);
        }

        // Check the rendering mode
        isReadOnlyMode = userPrefsServiceClient.isReadOnlyMode(loggeduser);
    } catch (Exception e) {
        CarbonUIMessage uiMsg = new CarbonUIMessage(CarbonUIMessage.ERROR, e.getMessage(), e);
        session.setAttribute(CarbonUIMessage.ID, uiMsg);
%>
<jsp:include page="../admin/error.jsp"/>
<%
        return;
    }
    if (dashboardName == null) {
        // Adding HTML wrapper tags
%>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <meta http-equiv="content-type" content="text/html;charset=utf-8"/>
    <title>WSO2 Gadget Server</title>
    <link href="../admin/css/global.css" rel="stylesheet" type="text/css"
          media="all"/>
    <link href="../dialog/css/jqueryui/jqueryui-themeroller.css"
          rel="stylesheet" type="text/css" media="all"/>
    <link href="../dialog/css/dialog.css" rel="stylesheet" type="text/css"
          media="all"/>

    <link href="localstyles/gadget-server.css" rel="stylesheet"
          type="text/css" media="all"/>

    <link rel="icon" href="../admin/images/favicon.ico" type="image/x-icon"/>
    <link rel="shortcut icon" href="../admin/images/favicon.ico"
          type="image/x-icon"/>

    <script type="text/javascript" src="../admin/js/main.js"></script>

    <script type="text/javascript" src="../admin/js/WSRequest.js"></script>
    <script type="text/javascript" src="../admin/js/cookies.js"></script>
</head>
<body>
<div id="dcontainer"></div>
<!--This is the link panel of the portal page-->
<div id="link-panel">
    <%if (!userLogedIn) { %>
    <ul>
        <li><strong>Create your account now!</strong></li>
        <li>|</li>
        <!--li><a href="../gsusermgt/login.jsp">Sign-in</a></li-->
        <li>
            <a href="javaScript:redirectToHttpsUrl('../gsusermgt/login.jsp', '<%=DashboardUiUtils.getHttpsPort(adminConsoleUrl)%>')">Sign-in</a>
        </li>
        <li>|</li>
        <li><a href="../../docs">Help</a></li>
    </ul>
    <%} else if (userLogedIn) { %>
    <ul>
        <li><strong>Signed-in as&nbsp;<%=loggeduser + tenantDomain%>
        </strong></li>
        <li>|</li>
        <!--li><a href="javaScript:redirectToHttpsUrl('../gsusermgt/login.jsp?action=signOut', '<%=DashboardUiUtils.getHttpsPort(adminConsoleUrl)%>')">Sign-out</a></li-->
        <li>
            <a href="javaScript:redirectToHttpsUrl('../admin/logout_action.jsp?IndexPageURL=/carbon/gsusermgt/middle.jsp', '<%=DashboardUiUtils.getHttpsPort(adminConsoleUrl)%>')">Sign-out</a>
        </li>

        <li>|</li>
        <li><a href="../../docs">Help</a></li>
    </ul>
    <%} %>
    <div class="left-logo"><a class="header-home" href="index.jsp">
        <img width="179" height="28" src="images/1px.gif"/> </a></div>
</div>
<%}%>
<!-- default container look and feel -->
<%
    if (dashboardName == null) {
%>
<link rel="stylesheet" href="localstyles/gadgets-gs.css">
<%} else {%>
<link rel="stylesheet" href="localstyles/gadgets.css">
<%}%>
<link href="localstyles/menu-style.css" rel="stylesheet"
      type="text/css" media="all"/>

<script type="text/javascript" src="javascript/jquery-1.2.6.min.js"></script>
<script type="text/javascript" src="javascript/jquery.menu.js"></script>

 <script type="text/javascript">
    // Setting the Dashboard name to be used in Javascript : setting this
    // here for it is used in gadgets.js
    <%
    if(dashboardName == null){
    %>
    var dashboardName = null;
    <%
    }else{
    %>
    var dashboardName = '<%=dashboardName%>';
    <%
    }
    %>
    var isReadOnly = <%=isReadOnlyMode%>;
 </script>

<script type="text/javascript" src="../../gadgets/js/core:rpc:pubsub?c=1&debug=1"></script>
<script type="text/javascript" src="javascript/cookies.js"></script>
<script type="text/javascript" src="javascript/json2.js"></script>
<script type="text/javascript" src="javascript/dojo.xd.js"></script>
<script type="text/javascript" src="javascript/util.js"></script>
<script type="text/javascript" src="javascript/gadgets.js"></script>
<%if (userLogedIn) { %>
<script type="text/javascript"
        src="javascript/userpref-service-stub.js"></script>
<%} else if (!userLogedIn) { %>
<script type="text/javascript"
        src="javascript/userpref-service-cookie-stub.js"></script>
<%} %>
<script type="text/javascript" src="javascript/encoder-decoder.js"></script>
<script type="text/javascript"
        src="javascript/registry-based-userpref-store.js"></script>
<script type="text/javascript" src="javascript/gadget-server-utils.js"></script>

<script type="text/javascript" src="javascript/tabs.js"></script>

<script type="text/javascript" src="javascript/portlet-config.js"></script>

<script type="text/javascript" src="javascript/jquery-ui-1.6.custom.min.js"></script>

<script type="text/javascript" src="../dialog/js/dialog.js"></script>
<%@include file="../dialog/display_messages.jsp" %>
<script type="text/javascript" src="javascript/gadgetsever.js"></script>
<script type="text/javascript">
    var backendHttpsPort = '<%=DashboardUiUtils.getHttpsPort(backendServerURL)%>';
    //Number of columns in the portal
    var userId = '<%=loggeduser%>';
    var gadgetGroup1 = new Array();
    var gadgetGroup2 = new Array();
    var gadgetGroup3 = new Array();


    // Setting browser language
    var localLanguage = '<%=request.getLocale().getLanguage()%>';

    // Setting country
    var localCountry = '<%=request.getLocale().getCountry()%>';

    // Storing the currently active tab
    var currentActiveTab = '<%=currentActiveTab%>';

    // Setting the HTTP server root to be used in Javascript
    var httpServerRoot = '<%=DashboardUiUtils.getHttpServerRoot(backendServerURL, userPrefsServiceClient.getBackendHttpPort())%>';
    gadgetserver.gadgetSpecUrls = new Array();
    <%
    if(gadgetUrls != null && gadgetUrls[0] != null) {
    for(int i=0; i<gadgetUrls.length; i++) {
        if(userLogedIn) {
    %>
    gadgetserver.gadgetSpecUrls[<%=i%>] = '<%=gadgetUrls[i]%>';
    <%	} else { %>
    gadgetserver.gadgetSpecUrls[<%=i%>] = '<%=gadgetUrls[i].split(",")[1]%>';
    <%	}
        }
    }%>

    //If the tab is not valid, make it the default tab 0
    if (!UserPrefsService.isValidTab(userId, currentActiveTab, dashboardName)) {
        currentActiveTab = '0';
    }
    gadgetserver.gadgetLayout = UserPrefsService.getGadgetLayout(userId, currentActiveTab, dashboardName).split(",");

    gadgetserver.refreshGadgetLayout = function() {
        gadgetserver.gadgetLayout = UserPrefsService.getGadgetLayout(userId, currentActiveTab, dashboardName).split(",");
    }

    if (gadgetserver.gadgetLayout != "NA") {
        for (var i = 0; i < gadgetserver.gadgetLayout.length; i++) {
            if (gadgetserver.gadgetLayout[i].split("#")[0] == "G1") {
                gadgetGroup1[gadgetGroup1.length] = gadgetserver.gadgetLayout[i].split("#")[1];
            } else if (gadgetserver.gadgetLayout[i].split("#")[0] == "G2") {
                gadgetGroup2[gadgetGroup2.length] = gadgetserver.gadgetLayout[i].split("#")[1];
            } else if (gadgetserver.gadgetLayout[i].split("#")[0] == "G3") {
                gadgetGroup3[gadgetGroup3.length] = gadgetserver.gadgetLayout[i].split("#")[1];
            }
        }
    }

    if (gadgetserver.gadgetLayout == "NA" && UserPrefsService.isNewUser()) {
        // We have to add the default URLs
        var p = 0;
        for (p = 0; p < gadgetserver.gadgetSpecUrls.length; p = p + 3) {
            UserPrefsService.addGadget(userId, currentActiveTab, gadgetserver.gadgetSpecUrls[p], dashboardName, "G1#");
        }
        for (p = 1; p < gadgetserver.gadgetSpecUrls.length; p = p + 3) {
            UserPrefsService.addGadget(userId, currentActiveTab, gadgetserver.gadgetSpecUrls[p], dashboardName, "G2#");
        }
        for (p = 2; p < gadgetserver.gadgetSpecUrls.length; p = p + 3) {
            UserPrefsService.addGadget(userId, currentActiveTab, gadgetserver.gadgetSpecUrls[p], dashboardName, "G3#");
        }
        // Refresh gadgetLayout with new data
        gadgetserver.gadgetLayout = UserPrefsService.getGadgetLayout(userId, currentActiveTab, dashboardName).split(",");

        for (var i = 0; i < gadgetserver.gadgetLayout.length; i++) {
            if (gadgetserver.gadgetLayout[i].split("#")[0] == "G1") {
                gadgetGroup1[gadgetGroup1.length] = gadgetserver.gadgetLayout[i].split("#")[1];
            } else if (gadgetserver.gadgetLayout[i].split("#")[0] == "G2") {
                gadgetGroup2[gadgetGroup2.length] = gadgetserver.gadgetLayout[i].split("#")[1];
            } else if (gadgetserver.gadgetLayout[i].split("#")[0] == "G3") {
                gadgetGroup3[gadgetGroup3.length] = gadgetserver.gadgetLayout[i].split("#")[1];
            }

        }
        gadgetserver.gadgetSpecUrls = UserPrefsService.getGadgetUrlsToLayout(userId, currentActiveTab, dashboardName);
    } else {
        // The user has a preferred set of gadgets in store. Retrieve them
        gadgetserver.gadgetSpecUrls = UserPrefsService.getGadgetUrlsToLayout(userId, currentActiveTab, dashboardName);
    }

    function optHandler() {
        if ($('.gadgets-top-links').is(':visible')) {
            $('.gadgets-top-links').hide();

            $('#handlerBut').html('Show Options');
            $('#handlerBut').css("background-image", "url(images/show.gif)");
        } else {
            $('.gadgets-top-links').show();
            $('#handlerBut').html('Hide Options');
            $('#handlerBut').css("background-image", "url(images/hide.gif)");
        }
    }

</script>

<fmt:bundle
        basename="org.wso2.carbon.dashboard.ui.resource.i18n.Resources">
    <carbon:jsi18n
            resourceBundle="org.wso2.carbon.dashboard.ui.resource.i18n.JSResources"
            request="<%=request%>"/>
    <%
        if (dashboardName != null) {
    %>
    <carbon:breadcrumb
            label="Dashboard"
            resourceBundle="org.wso2.carbon.dashboard.ui.resource.i18n.Resource"
            topPage="false"
            request="<%=request%>"/>
    <%
        }
    %>
    <div id="middle">

        <%
            if (dashboardName != null) {
        %>
        <h2><fmt:message key="dashboard"/></h2>
        <%
            }
        %>

        <div id="workArea">
            <table width="100%" height="100%" cellspacing="0">
                <tr>
                    <td style="background-color: #FFFFFF;">
                        <%if (!userLogedIn) {%>
                            <%@include file="includes/gs-gadget-top-links-anon.html" %>
                        <%} else if (userLogedIn && (dashboardName == null)) { %>
                            <%@include file="includes/gs-gadget-top-links.html" %>
                        <%} else if (userLogedIn && (dashboardName != null) && !isReadOnlyMode) { %>
                            <%if ("true".equals(hideOptions)) {%>
                                <a id="handlerBut" href="javascript:optHandler();" style="background-image:url(images/show.gif);">Show Options</a>
                                <ul class="gadgets-top-links" style="display:none;">
                             <%} else{%>
                                <ul class="gadgets-top-links">
                             <%}%>
                                 <%@include file="includes/gadget-top-links-product.html" %>
                                </ul>
                        <% } %>
                        <%if (!userLogedIn) { %>
                                <div id="newGadgetsPane" style="display: none;">
                                    <table class="defaultGadgets" width="100%">
                                        <tr>
                                            <form id="newGadgetForm" name="newGadgetForm">
                                                <%
                                                    if (gadgetUrls != null) {

                                                        for (int x = 0; x < gadgetUrls.length; x = x + 4) {
                                                            out.print("<td width='250' nowrap='nowrap'>");
                                                            for (int i = x; i < 4 * ((x / 4) + 1); i++) {
                                                                if (i >= gadgetUrls.length) break;
                                                                String[] nameUrlPair = gadgetUrls[i].split(",");
                                                %>

                                                <input type="checkbox" name="checkgroup"
                                                       value="<%=nameUrlPair[1]%>"><%=nameUrlPair[0] %>
                                                </input><br/>

                                                <%

                                                            }
                                                            out.print("</td>");
                                                        }
                                                        out.print("<td width='100%'>&nbsp;</td>");
                                                    }
                                                %>

                                            </form>
                                        </tr>
                                        <tr>
                                            <td colspan="4"><br/>&nbsp;<input type="button"
                                                                              class="button"
                                                                              onclick="gadgetserver.saveNewUserGadgets()"
                                                                              value="Add">&nbsp;<input
                                                    type="button"
                                                    class="button"
                                                    onclick="gadgetserver.cancelPane()"
                                                    value="Cancel">
                                            </td>
                                        </tr>
                                    </table>
                                </div>
                                        <%} %>

                                <script type="text/javascript">
                                    document.write("<ul id=\"tabmenu\">");
                                    var tabLayout = UserPrefsService.getTabLayout(userId, dashboardName).split(",");
                                    var x = 0;
                                    for (x = 0; x < tabLayout.length; x++) {
                                        var tabTitle = UserPrefsService.getTabTitle(userId, tabLayout[x], dashboardName);
                                        if (currentActiveTab == tabLayout[x]) {
                                            document.write("<li onclick=\"makeActive(" + tabLayout[x] + ")\"><a class=\"active\" id=\"tab" + tabLayout[x] + "\">" + tabTitle + "</a></li>");
                                        } else {
                                            document.write("<li onclick=\"makeActive(" + tabLayout[x] + ")\"><a class=\"\" id=\"tab" + tabLayout[x] + "\">" + tabTitle + "</a></li>");
                                        }
                                    }
                                    document.write("</ul>");
                                    //document.write(">");
                                </script>
                                <div id="pre-loader" style="width:100%">
                                    <center><img src="images/loading.gif"/></center>
                                </div>
                                <script type="text/javascript">
                                    document.write("<div id=\"page\" style=\"display:none;\">");
                                    document.write("<div id=\"group1\" class=\"section\"><div class=\"sectionTop\"></div>");

                                    for (var z = 0; z < gadgetGroup1.length; z++) {
                                        document.write("<div id=\"gadget-chrome_" + gadgetGroup1[z] + "\" class=\"lineitem gadgets-gadget-chrome\"></div>");
                                    }

                                    document.write("</div>");
                                    document.write("<div id=\"group2\" class=\"section\"><div class=\"sectionTop\"></div>");

                                    for (var z = 0; z < gadgetGroup2.length; z++) {
                                        document.write("<div id=\"gadget-chrome_" + gadgetGroup2[z] + "\" class=\"lineitem gadgets-gadget-chrome\"></div>");
                                    }

                                    document.write("</div>");
                                    document.write("<div id=\"group3\" class=\"section\"><div class=\"sectionTop\"></div>");

                                    for (var z = 0; z < gadgetGroup3.length; z++) {
                                        document.write("<div id=\"gadget-chrome_" + gadgetGroup3[z] + "\" class=\"lineitem gadgets-gadget-chrome\"></div>");
                                    }

                                    document.write("</div>");
                                    document.write("</div>");
                                </script>


                    </td>
                </tr>
                <tr>
                    <td height="100%" style="background-color: #FFFFFF;">
                        <div id="maximizedGadget"
                             style="width: 100%; min-height: 100%; display: none;"></div>
                    </td>
                </tr>
                <tr>
                    <td style="background-color: #FFFFFF;"><img width="1" height="1"
                                                                src="images/1px.gif"/></td>
                </tr>
                <%
                    if (dashboardName == null) {
                        // Adding HTML wrapper tags
                %>
                <tr>
                    <td height="20">
                        <div class="footer-content">
                            <div class="copyright">&copy; 2008 - 2010 WSO2 Inc. All Rights
                                Reserved.
                            </div>
                        </div>
                    </td>
                </tr>
                <%
                    }
                %>
            </table>
        </div>
        <%
            if (dashboardName != null) {
        %>
        <script type="text/javascript">
            // This is needed in product mode to fix the bread crumb not having the correct link.
            fixBreadCrumb('<%=dashboardName%>');
        </script>
        <%
            }
        %>
    </div>
</fmt:bundle>
<%
    if (dashboardName == null) {
        // Adding HTML wrapper tags
%>
</body>
</html>
<%
    }
%>